# std::stack< _Tp, _Sequence > Class Template Reference
[Containers, Sequences]

List of all members.

## Detailed Description

### template<typename _Tp, typename _Sequence = deque<_Tp>>
class std::stack< _Tp, _Sequence >

Meets many of the requirements of a container, but does not define anything to do with iterators. Very few of the other standard container interfaces are defined.

This is not a true container, but an adaptor. It holds another container, and provides a wrapper interface to that container. The wrapper is what enforces strict first-in-last-out stack behavior.

The second template parameter defines the type of the underlying sequence/container. It defaults to std::deque, but it can be any type that supports `back`, `push_back`, and `pop_front`, such as std::list, std::vector, or an appropriate user-defined type.

Members not found in "normal" containers are `container_type`, which is a typedef for the second Sequence parameter, and `push`, `pop`, and `top`, which are standard stack/FILO operations.

Definition at line 98 of file stl_stack.h.

## Public Types

- typedef _Sequence::const_reference const_reference
- typedef _Sequence container_type
- typedef _Sequence::reference reference
- typedef _Sequence::size_type size_type
- typedef _Sequence::value_type value_type

## Public Member Functions

- bool empty () const
- void pop ()
- void push (const value_type &__x)
- size_type size () const
- stack (const _Sequence &__c=_Sequence())
- const_reference top () const
- reference top ()

## Protected Attributes

- _Sequence c

## Friends

- template<typename _Tp1, typename _Seq1> bool operator< (const stack< _Tp1, _Seq1 > &, const stack< _Tp1, _Seq1 > &)
- template<typename _Tp1, typename _Seq1> bool operator== (const stack< _Tp1, _Seq1 > &, const stack< _Tp1, _Seq1 > &)

## Constructor & Destructor Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

std::stack< _Tp, _Sequence >::stack | ( | const _Sequence & | __c = `_Sequence()` | ) | `[inline, explicit]`

Default constructor creates no elements.

Definition at line 131 of file stl_stack.h.

## Member Function Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

bool std::stack< _Tp, _Sequence >::empty | ( |  | ) | const`[inline]`

Returns true if the stack is empty.

Definition at line 138 of file stl_stack.h.

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::stack< _Tp, _Sequence >::pop | ( |  | ) | `[inline]`

Removes first element.

This is a typical stack operation. It shrinks the stack by one. The time complexity of the operation depends on the underlying sequence.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop() is called.

Definition at line 193 of file stl_stack.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::stack< _Tp, _Sequence >::push | ( | const value_type & | __x | ) | `[inline]`

Add data to the top of the stack.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the top of the stack and assigns the given data to it. The time complexity of the operation depends on the underlying sequence.

Definition at line 178 of file stl_stack.h.

template<typename _Tp, typename _Sequence = deque<_Tp>>

size_type std::stack< _Tp, _Sequence >::size | ( |  | ) | const`[inline]`

Returns the number of elements in the stack.

Definition at line 143 of file stl_stack.h.

template<typename _Tp, typename _Sequence = deque<_Tp>>

const_reference std::stack< _Tp, _Sequence >::top | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the first element of the stack.

Definition at line 162 of file stl_stack.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

reference std::stack< _Tp, _Sequence >::top | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the first element of the stack.

Definition at line 151 of file stl_stack.h.

References __glibcxx_requires_nonempty.

The documentation for this class was generated from the following file:

- stl_stack.h